"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantAnnotation(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import opencb as opencb_1_3_0

        return {
            "additionalAttributes": opencb_1_3_0.AdditionalAttribute,
            "consequenceTypes": opencb_1_3_0.ConsequenceType,
            "conservation": opencb_1_3_0.Score,
            "cytoband": opencb_1_3_0.Cytoband,
            "drugs": opencb_1_3_0.Drug,
            "functionalScore": opencb_1_3_0.Score,
            "geneDrugInteraction": opencb_1_3_0.GeneDrugInteraction,
            "geneExpression": opencb_1_3_0.Expression,
            "geneTraitAssociation": opencb_1_3_0.GeneTraitAssociation,
            "populationFrequencies": opencb_1_3_0.PopulationFrequency,
            "repeat": opencb_1_3_0.Repeat,
            "traitAssociation": opencb_1_3_0.EvidenceEntry,
            "variantTraitAssociation": opencb_1_3_0.VariantTraitAssociation,
            "xrefs": opencb_1_3_0.Xref,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import opencb as opencb_1_3_0

        return {
            "org.opencb.biodata.models.variant.avro.AdditionalAttribute": opencb_1_3_0.AdditionalAttribute,
            "org.opencb.biodata.models.variant.avro.ConsequenceType": opencb_1_3_0.ConsequenceType,
            "org.opencb.biodata.models.variant.avro.Score": opencb_1_3_0.Score,
            "org.opencb.biodata.models.variant.avro.Cytoband": opencb_1_3_0.Cytoband,
            "org.opencb.biodata.models.variant.avro.Drug": opencb_1_3_0.Drug,
            "org.opencb.biodata.models.variant.avro.Score": opencb_1_3_0.Score,
            "org.opencb.biodata.models.variant.avro.GeneDrugInteraction": opencb_1_3_0.GeneDrugInteraction,
            "org.opencb.biodata.models.variant.avro.Expression": opencb_1_3_0.Expression,
            "org.opencb.biodata.models.variant.avro.GeneTraitAssociation": opencb_1_3_0.GeneTraitAssociation,
            "org.opencb.biodata.models.variant.avro.PopulationFrequency": opencb_1_3_0.PopulationFrequency,
            "org.opencb.biodata.models.variant.avro.Repeat": opencb_1_3_0.Repeat,
            "org.opencb.biodata.models.variant.avro.EvidenceEntry": opencb_1_3_0.EvidenceEntry,
            "org.opencb.biodata.models.variant.avro.VariantTraitAssociation": opencb_1_3_0.VariantTraitAssociation,
            "org.opencb.biodata.models.variant.avro.Xref": opencb_1_3_0.Xref,
            "org.opencb.biodata.models.variant.avro.VariantAnnotation": opencb_1_3_0.VariantAnnotation,
        }

    __slots__ = [
        "additionalAttributes",
        "alternate",
        "ancestralAllele",
        "chromosome",
        "consequenceTypes",
        "conservation",
        "cytoband",
        "displayConsequenceType",
        "drugs",
        "end",
        "functionalScore",
        "geneDrugInteraction",
        "geneExpression",
        "geneTraitAssociation",
        "hgvs",
        "id",
        "minorAllele",
        "minorAlleleFreq",
        "populationFrequencies",
        "reference",
        "repeat",
        "start",
        "traitAssociation",
        "variantTraitAssociation",
        "xrefs",
    ]

    def __init__(
        self,
        additionalAttributes=None,
        alternate=None,
        ancestralAllele=None,
        chromosome=None,
        consequenceTypes=list,
        conservation=None,
        cytoband=None,
        displayConsequenceType=None,
        drugs=None,
        end=None,
        functionalScore=None,
        geneDrugInteraction=None,
        geneExpression=None,
        geneTraitAssociation=None,
        hgvs=None,
        id=None,
        minorAllele=None,
        minorAlleleFreq=None,
        populationFrequencies=None,
        reference=None,
        repeat=None,
        start=None,
        traitAssociation=None,
        variantTraitAssociation=None,
        xrefs=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_3_0.VariantAnnotation model.

        :param additionalAttributes:
        :type additionalAttributes: None | dict[str, AdditionalAttribute]
        :param alternate:
        :type alternate: None | str
        :param ancestralAllele:
        :type ancestralAllele: None | str
        :param chromosome:
        :type chromosome: None | str
        :param consequenceTypes:
        :type consequenceTypes: list[ConsequenceType]
        :param conservation:
        :type conservation: None | list[Score]
        :param cytoband:
        :type cytoband: None | list[Cytoband]
        :param displayConsequenceType:
        :type displayConsequenceType: None | str
        :param drugs:
        :type drugs: None | list[Drug]
        :param end:
        :type end: None | int
        :param functionalScore:
        :type functionalScore: None | list[Score]
        :param geneDrugInteraction:
        :type geneDrugInteraction: None | list[GeneDrugInteraction]
        :param geneExpression:
        :type geneExpression: None | list[Expression]
        :param geneTraitAssociation:
        :type geneTraitAssociation: None | list[GeneTraitAssociation]
        :param hgvs:
        :type hgvs: None | list[str]
        :param id:
        :type id: None | str
        :param minorAllele:
        :type minorAllele: None | str
        :param minorAlleleFreq:
        :type minorAlleleFreq: None | float
        :param populationFrequencies:
        :type populationFrequencies: None | list[PopulationFrequency]
        :param reference:
        :type reference: None | str
        :param repeat:
        :type repeat: None | list[Repeat]
        :param start:
        :type start: None | int
        :param traitAssociation:
        :type traitAssociation: None | list[EvidenceEntry]
        :param variantTraitAssociation:
        :type variantTraitAssociation: None | VariantTraitAssociation
        :param xrefs:
        :type xrefs: None | list[Xref]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
